import { UserService } from './../../shared/user.service';
import { Router, ActivatedRoute } from '@angular/router';
import { AuthServiceService } from './../../shared/auth-service.service';
import { Component, OnInit, AfterViewInit, ViewChild, EventEmitter } from '@angular/core';
import { InternalPageService } from '../../shared/internal-page.service';
import { NgxSpinnerService } from 'ngx-spinner';
import {NgbCarousel,NgbCarouselConfig} from '@ng-bootstrap/ng-bootstrap';
import {SlimScroll} from 'angular2-slimscroll';
import { ISlimScrollOptions, SlimScrollEvent } from 'ngx-slimscroll';


@Component({
  selector: 'app-internal-page-content',
  templateUrl: './internal-page-content.component.html',
  styleUrls: ['./internal-page-content.component.css'],
  providers: [NgbCarouselConfig],
})
export class InternalPageContentComponent implements OnInit {

  @ViewChild('myCarousel') myCarousel: NgbCarousel;


  constructor(private authSer: AuthServiceService,
    private router:Router,
    private userservice: UserService,
    private internalService: InternalPageService,
    private route: ActivatedRoute,
    private config: NgbCarouselConfig,
    private spinner: NgxSpinnerService) {
      this.config.interval = 10000;
       this.config.wrap = false;
      this.config.keyboard = false;

     }


  


    joinUs = [];
    reportsData = [];
    externalServices = [];
    congratulations = [];
    condolences = [];
    internalServices = [];
    tabsData = [];
    achievements = [];
    checkShowData: boolean;
    tabtype:number = 0;
    expandedIndex:number;
    live_event = [];
    next_lecture = [];
    myInnerHeight = window.innerHeight;


    flag: boolean = false;

    catchEvent(event) {
      this.flag = true
      console.log(event)
    }

    hide(event) {
      this.flag = false;
    }


    opts: ISlimScrollOptions;
    scrollEvents: EventEmitter<SlimScrollEvent>;

  ngOnInit() {

    this.spinner.show();

    this.authSer.arabicTemplate = true;
    this.authSer.arabicLanguage = true;
    this.authSer.englishLanguage = false;

    // this.myCarousel.activeId = '2';

    //this.spinner.show();
    this.authSer.showDashboardHeader = false;
   //console.log(this.checkTokenExpire);
       //get profile data
    this.userservice.getUserDataProfile();

    this.scrollEvents = new EventEmitter<SlimScrollEvent>();
    this.opts = {
      position: "left", // left | right
      barBackground: "#C9C9C9", // #C9C9C9
      barOpacity: "0.8", // 
      barWidth: "10", // 10
      barBorderRadius: "20", // 20
      barMargin: "0", // 0
      gridBackground: "#D9D9D9", // #D9D9D9
      gridOpacity: "1", // 1
      gridWidth: "2", // 2
      gridBorderRadius: "20", // 20
      gridMargin: "0", // 0
      alwaysVisible: true, // true
      visibleTimeout: 1000, // 1000
    }

    this.play();
  
    //get slider data
    this.internalService.getSliderData().subscribe(
      (responce) => {
        console.log('responxce', responce);
        this.reportsData = responce['reports'];
        for(let i = 0; i< this.reportsData.length; i++) {
          if(this.reportsData[i].description.length > 60) {
            this.reportsData[i].description = this.reportsData[i].description.substr(0,60);
            this.reportsData[i].description_en = this.reportsData[i].description_en.substr(0,60);
          }
        }
      },
      (error) => {
        console.log(error);
      }
    );

    //get externals list
    this.internalService.getExternalServicesList().subscribe(
      (responce) => {
        this.externalServices = responce['external_services'];
      },
      (error) => {
        console.log(error);
      }
    );

    //get join us data
    this.internalService.getJoinUsData().subscribe(
      (responce) => {
        console.log('joooin us', responce);
        this.joinUs = responce['user'];
      },
      (error) => {
        console.log(error);
      }
    );

    this.internalService.getCongatoration().subscribe(
      (responce) => {
        this.congratulations = responce['event'];
      },
      (error) => {
        console.log(error);
      }
    );

    this.internalService.getCondolences().subscribe(
      (responce) => {
        this.condolences = responce['event'];
      },
      (error) => {
        console.log(error);
      }
    );

    this.internalService.getInternalServicesList().subscribe(
      (responce) => {
        console.log('internal serviceees',responce);
        this.internalServices = responce['internal_services'];
      },
      (error) => {
        console.log(error);
      }
    );

    this.internalService.getTabData(this.tabtype).subscribe(
      (responce) => {
        this.tabsData = responce['tabs'];
        if(this.tabsData.length > 0) {
          this.checkShowData = false;
        } else {
          this.checkShowData = true;
        }
      },
      (error) => {
        console.log(error);
      }
    );

    this.internalService.getForthAchievementsList().subscribe(
      (responce) => {
        console.log('weeeeeeeeeeeeeeeeeeee', responce);
        this.achievements = responce['achievements'];
      },
      (error) => {
        console.log(error);
      }
    );

    this.internalService.getEventNow().subscribe(
      (responce) => {
        this.live_event = responce['live_lecture'];
        this.next_lecture = responce['next_lecture'];
        this.spinner.hide();
      },
      (error) => {
        console.log(error);
      }
    );

  }


  onGetData(numberTab) {
    this.spinner.show();
    this.tabsData = [];
    this.tabtype = numberTab;
    this.internalService.getTabData(this.tabtype).subscribe(
      (responce) => {
        this.tabsData = responce['tabs'];
        if(this.tabsData.length > 0) {
          this.checkShowData = false;
        } else {
          this.checkShowData = true;
        }
        this.spinner.hide();
      },
      (error) => {
        console.log(error);
      }
    )
  }

  onExtraPage(reportId) {
    this.router.navigate(['InternalPage/news/' + reportId]);
  }

  open(data,i) {
    console.log(data);
    this.expandedIndex = i;
  }

  closeCollapse(i) {
    this.expandedIndex = -1;
  }

  goToHome() {
    this.router.navigate(['InternalPage']);
  }

  onPageCir() {
    this.router.navigate(['InternalPage/circulars']);
  }

  onLectureTable() {
    this.router.navigate(['InternalPage/events']);
  }

  play(): void {
    let event = null;

    Promise.resolve()
      .then(() => this.timeout(3000))
      .then(() => {
        event = new SlimScrollEvent({
          type: 'scrollToBottom',
          duration: 2000,
          easing: 'inOutQuad'
        });

        this.scrollEvents.emit(event);
      })
      .then(() => this.timeout(3000))
      .then(() => {
        event = new SlimScrollEvent({
          type: 'scrollToTop',
          duration: 3000,
          easing: 'outCubic'
        });

        this.scrollEvents.emit(event);
      })
      .then(() => this.timeout(4000))
      .then(() => {
        event = new SlimScrollEvent({
          type: 'scrollToPercent',
          percent: 80,
          duration: 1000,
          easing: 'linear'
        });

        this.scrollEvents.emit(event);
      })
      .then(() => this.timeout(2000))
      .then(() => {
        event = new SlimScrollEvent({
          type: 'scrollTo',
          y: 200,
          duration: 4000,
          easing: 'inOutQuint'
        });

        this.scrollEvents.emit(event);
      });
  }

  timeout(ms: number): Promise<void> {
    return new Promise(resolve => setTimeout(() => resolve(), ms));
  }

}
